100 REMark WordsCheck by Dilwyn Jones 1989, revised 2002
110 IMPLICIT% a,key,cur_cde
120 :
130 DIM version$(4)      : version$ = '1.92' : REMark program version
140 DIM def_drive$(40)   : REMark default drive name
150 DIM wcard$(40)       : REMark wildcard suffix in filenames
160 wcard$ = '_txt'      : REMark wildcard
170 def_drive$ = 'flp1_' : REMark mdv version change
180 :
190 REMark display
200 IF COMPILED THEN
210   OPEN #0,'con'
220   WHEN_ERROR 0
230     PRINT #0,'@ line ';ERLIN%;
240     REPORT_AN_ERROR ERNUM%
250     CURSOR_ON #0! : PAUSE 250 : CURSOR_OFF #0
260     RETRY
270   END_WHEN
280 END IF
290 WINDOW #0,448,202,32,15 : PAPER #0,0 : INK #0,7
300 BORDER #0,1,255 : CLS #0
310 :
320 DIM pf$(42),printer$(42),v$(6) : REMark v$ is values entry string
330 pf$ = '' : printer$ = 'ser1'
340 base      = 0 : REMark no file in heap yet
350 base_addr = 0 : REMark no heap word list yet
360 :
370 REPeat program
380   REMark opening titles
390   CLS #0 : BLOCK #0,444,22,0,50,0,4,0 : BLOCK #0,444,15,0,118,0,4,0
400   INK #0,2 : OVER #0,1 : CSIZE #0,3,1
410   FOR a = 0 TO 2 : CURSOR #0,140+a,50+(a/2) : PRINT #0,'WORDSCHECK'
420   INK #0,7 : CURSOR #0,143,50+2 : PRINT #0,'WORDSCHECK'
430   CSIZE #0,0,0 : PRINT #0,\TO 30;'(Version ';version$;')'
440   CSIZE #0,3,0 : INK #0,2
450   FOR a = 0 TO 2
460     CURSOR #0,70+a,120+(a/2) : PRINT #0,CHR$(127)&' DILWYN JONES 1989'
470   END FOR a
480   INK #0,7 : CURSOR #0,73,122 : PRINT#0,CHR$(127)&' DILWYN JONES 1989'
490   OVER #0,0 : CSIZE #0,0,0
500   :
510   IF base_addr > 0 THEN DEALLOCATE base_addr : base_addr = 0
520   :
530   REMark initialise/reset arrays
540   base = 0  : REMark heap storage for document
550   DIM k$(2) : REMark general keyboard reading
560   :
570   REPeat startup
580     REMark get free memory, but leave at least 4k free for QDOS!
590     REMark best of course to leave enough free to load file for speed
600     REMark important to test this each time round this loop in case
610     REMark user CTRL C's out of program in between to free up memory
620     fr_mem = FREE_MEM : REMark v1.19 change for QPC2 free memory
630     :
640     REPeat loop
650       AT #0,15,0 : CLS #0,3 : CLS #0,2 : REMark line and bottom
660       INPUT #0,'Length of longest word (even value, 2-30):';v$
670       IF v$ = '' THEN EXIT startup
680       longest_word = '0'&v$
690       IF longest_word > 1 AND longest_word < 31 AND (longest_word MOD 2)<>1 THEN EXIT loop
700       BEEP 5000,50 : PRINT #0,'Invalid entry.' : PAUSE 50
710     END REPeat loop
720     entry_length = longest_word + 6
730     max_entries = INT(fr_mem/entry_length)
740     :
750     REPeat loop
760       AT #0,17,0 : CLS #0,3 : CLS #0,4
770       INPUT #0,'How many different words (maximum=';(max_entries);'):';v$
780       highest_entry = '0'&v$ : IF v$ = '' THEN NEXT startup
790       IF highest_entry = INT(highest_entry) AND highest_entry > 0 AND highest_entry <= max_entries THEN EXIT loop
800       BEEP 5000,50 : PRINT #0,'Invalid entry.' : PAUSE 50
810     END REPeat loop
820     :
830     REMark try to allocate enough memory for this list now
840     base_addr = ALLOCATION(highest_entry*entry_length)
850     IF base_addr <= 0 THEN
860       AT #0,14,0 : CLS #0,2 : REPORT_AN_ERROR base_addr
870       PAUSE 50 : NEXT startup
880     END IF
890     :
900     EXIT startup
910   END REPeat startup
920   IF v$ = '' THEN EXIT program : REMark just ENTER pressed, abandon
930   :
940   REMark fill up heap area with NULs
950   POKE base_addr,0 : MOVE_MEMORY base_addr TO base_addr+1,(highest_entry*entry_length)-1 : REMark positive length overwrites I hope
960   :
970   CLS #0 : PRINT #0,'Select method of dealing with apostrophes:'
980   PRINT #0,\'  1 = ignore apostrophes'
990   PRINT #0,'  2 = apostrophe signifies end of word'
1000   PRINT #0,"  3 = join 's etc to word end"
1010   PRINT #0,\'Select option 1-3 or ESC > ';
1020   REPeat loop
1030     CURSOR_ON #0! : apostrophes = CODE(INKEY$(-1)) : CURSOR_OFF #0
1040     IF apostrophes = 27 : EXIT program : REMark Quit
1050     SELect ON apostrophes = 49 TO 51 : PRINT#0,CHR$(apostrophes):EXIT loop
1060     BEEP 5000,50
1070   END REPeat loop
1080   :
1090   DIM drive_name$(42) : REMark name of drive in list_of_files
1100   DIM filename$(40)   : REMark general filename used in list_of_files
1110   DIM this_entry$(256): REMark text from file since end of last word
1120   DIM this_char$(2)   : REMark current character fetched from file
1130   DIM fetch$(1024)    : REMark fetch _doc text 1K blocks at a time
1140   DIM test%(3)        : REMark more often than, less often than
1150                       : REMark longer than, shorter than (print
1160                       : REMark tests for words)
1170   :
1180   REPeat get_filename
1190     RETRY_HERE : CLS #0
1200     PRINT #0,'Enter filename of text file to check (? for list, ESC to quit):'
1210     PRINT #0,def_drive$;
1220     CURSOR_ON #0! : key = CODE(INKEY$(-1)) : CURSOR_OFF #0
1230     SELect ON key
1240       =27 : AT #0,1,0 : CLS #0,4 : PRINT #0,'<ESC>' : CURSOR_ON #0!
1250         PAUSE 25 : CURSOR_OFF #0 : EXIT get_filename
1260         REMark remember to ask Quit y/n? at end of "program" loop
1270       =63:REMark list of files
1280         LIST_OF_FILES
1290         IF COMPILED THEN
1300           WHEN_ERROR 0
1310             REPORT_AN_ERROR ERNUM%
1320             CURSOR_ON #0! : PAUSE 100 : CURSOR_OFF #0 : RETRY
1330           END_WHEN
1340         END IF
1350         NEXT get_filename
1360       =244,250:REMark refresh
1370         MODE 4 : WINDOW #0,512,256,0,0 : PAPER #0,0 : CLS #0
1380         WINDOW #0,448,202,32,15 : BORDER #0,1,255 : NEXT get_filename
1390       =REMAINDER : REMark change to filename
1400         CURSOR_ON #0! : TYPE_IN CHR$(key) : CURSOR_OFF #0 : AT #0,1,0
1410         filename$ = EDIT$(#0,def_drive$,41)
1420         IF filename$ = '' THEN key = 27 : EXIT get_filename
1430         IF filename$ = '?' THEN
1440           LIST_OF_FILES
1450           IF COMPILED THEN
1460             WHEN_ERROR 0
1470               REPORT_AN_ERROR ERNUM%
1480               CURSOR_ON #0! : PAUSE 100 : CURSOR_OFF #0 : RETRY
1490             END_WHEN
1500           END IF
1510         END IF
1520         fer = DEVICE_STATUS(1,filename$)
1530         IF fer < 0 THEN
1540           REPORT_AN_ERROR fer : CURSOR_ON #0!
1550           PAUSE 100 : CURSOR_OFF #0 : NEXT get_filename
1560         END IF
1570         EXIT get_filename
1580     END SELect
1590   END REPeat get_filename
1600   :
1610   IF key = 27 THEN
1620     CLS #0 : PRINT #0,'Quit now (y/n)?';
1630     IF YN$ == 'y' THEN EXIT program : ELSE NEXT program : END IF
1640   END IF
1650   :
1660   REMark check if a _doc file
1670   REMark pre-v1.92 file length limited to 1E6 by SET_POSITION
1680   REMark so this version uses FLEN
1690   OPEN_IN #3,filename$ : length = FLEN(#3)
1700   SET_POSITION #3,0 : REMark TOTAL length of file, not just text
1710   file_type% = 1 : REMark assume ASCII file
1720   IF length >= 22 THEN
1730     REMark couldn't possibly be a _doc file if shorter than 22
1740     IF INPUT$(#3,2) = CHR$(0)&CHR$(20) THEN
1750       IF INPUT$(#3,8) == 'vrm1qdf0' THEN
1760         REMark _doc file header present
1770         byte = CODE(INKEY$(#3)) : fl=byte*256*256*256
1780         byte = CODE(INKEY$(#3)) : fl=fl+(byte*256*256)
1790         byte = CODE(INKEY$(#3)) : fl=fl+(byte*256)
1800         byte = CODE(INKEY$(#3)) : fl=fl+byte
1810         IF fl > length THEN fl = length-1
1820         end_pos = fl : REMark position in file of last text char.
1830         SET_POSITION #3,20 : REMark header starts here
1840         REMark skip header
1850         REPeat loop
1860           IF EOF(#3) : EXIT loop
1870           IF INKEY$(#3) = CHR$(0) : EXIT loop
1880         END REPeat loop
1890         REMark skip footer
1900         REPeat loop
1910           IF EOF(#3) : EXIT loop
1920           IF INKEY$(#3) = CHR$(0) : EXIT loop
1930         END REPeat loop
1940         start_pos = POSITION(#3):REMark posn of 1st char in the file
1950         IF EOF(#3) THEN SET_POSITION #3,20 : start_pos = 20
1960         SET_POSITION #3,start_pos : REMark goto first text character
1970         file_type% = 0 : REMark _doc file
1980       END IF
1990     END IF
2000   END IF
2010   :
2020   IF file_type% = 1 THEN
2030     REMark treat as an ASCII file, whatever non-_doc file it is
2040     start_pos = 0 : end_pos = length - 1
2050   END IF
2060   :
2070   REMark try to reserve memory
2080   byts = end_pos - start_pos + 1 : REMark length of text in file
2090   base = ALLOCATION(byts)
2100   IF base < 0 THEN
2110     PRINT #0,'Insufficient free memory to load the file, reading the wordsdirect from '!filename$(1 TO 5)&'...'
2120     PRINT #0,'DO NOT REMOVE THE DISC!!!'\'Counting...'
2130     COUNT_WORDS 1 : REMark count words direct from the file (slow!)
2140   ELSE
2150     REMark load file according to type
2160     IF file_type% = 1 THEN
2170       REMark use LBYTES for fast loading of ASCII files
2180       CLOSE #3 : PRINT #0,'Loading'!filename$
2190       LBYTES filename$,base
2200     ELSE
2210       REMark use INPUT$ to load _doc file, text only, 1K at a time
2220       address_ = base : REMark where next 1K text block goes
2230       FOR fp = 0 TO byts-1024 STEP 1024
2240         fetch$ = INPUT$(#3,1024)
2250         POKE$ address_,fetch$ : address_ = address_ + 1024
2260       NEXT fp
2270         IF (byts - (1024*INT(byts/1024))) <> 0 THEN
2280           fetch$ = INPUT$(#3,byts-(1024*INT(byts/1024)))
2290           POKE$ address_,fetch$
2300         END IF
2310       END FOR fp
2320     END IF
2330     PRINT #0,'Counting...' : COUNT_WORDS 2
2340   END IF
2350   :
2360   IF base > 0 THEN DEALLOCATE base : base = 0
2370   :
2380   CLS #0 : PRINT #0,'Quit now (y/n)?';
2390   IF YN$ == 'y' THEN EXIT program
2400 END REPeat program
2410 :
2420 Clear_Heap : REMark clear any heap allocations
2430 :
2440 IF NOT COMPILED THEN
2450   WINDOW #2,448,200,32,16 : WINDOW 448,200,32,16
2460   WINDOW #0,448,40,32,216 : REMark restore basic windows
2470 END IF
2480 :
2490 PRINT#0,'Program finished.'
2500 STOP
2510 :
2520 DEFine PROCedure Clear_Heap
2530   REMark for BASIC use, remove the heap blocks ALLOCATEd
2540   IF base > 0 THEN DEALLOCATE base : base = 0
2550   IF base_addr > 0 THEN DEALLOCATE base_addr : base_addr = 0
2560 END DEFine Clear_Heap
2570 :
2580 DEFine PROCedure SET_PRINT_QUALIFIERS
2590   LOCal loop
2600   CLS #0
2610   PRINT #0,'Specify any length or occurrences qualifiers for words printed (y/n)?';
2620   IF YN$ == 'n' THEN
2630     qualifiers% = 0 : REMark print without doing any tests
2640   ELSE
2650     AT #0,2,0
2660     qualifiers% = 1 : REMark tests to be done before printing word
2670     UNDER #0,1
2680     PRINT #0,'SPECIFY PRINTING QUALIFIERS BELOW FOR WORDS TO BE PRINTED'
2690     UNDER #0,0 : INK #0,2
2700     PRINT #0,\'(Length of longest word:';longest%;'. Highest occurrence:';oftenest%;')'
2710     PRINT #0, : INK #0,4 : PRINT #0,'OCCURRENCES:'; : INK #0,7
2720     PRINT #0,'More than ';test%(0) TO 28;'Less than ';test%(1) TO 43;' times'
2730     INK #0,4 : PRINT #0,'WORD LENGTH:'; : INK #0,7
2740     PRINT #0,'More than ';test%(2) TO 28;'Less than ';test%(3) TO 43;' characters'
2750     REPeat loop
2760       AT #0,6,22
2770       test%(0) = EDIT%(#0,test%(0),5) : REMark more often than
2780       IF test%(0) >= 0 THEN EXIT loop
2790       BEEP 5000,70
2800     END REPeat loop
2810     REPeat loop
2820       AT #0,6,38
2830       test%(1) = EDIT%(#0,test%(1),5) : REMark less often than
2840       IF test%(1) >= test%(0) THEN EXIT loop
2850       BEEP 5000,70
2860     END REPeat loop
2870     REPeat loop
2880       AT #0,7,22
2890       test%(2) = EDIT%(#0,test%(2),5) : REMark longer than
2900       IF test%(2) >= 0 THEN EXIT loop
2910       BEEP 5000,70
2920     END REPeat loop
2930     REPeat loop
2940       AT #0,7,38
2950       test%(3) = EDIT%(#0,test%(3),5) : REMark shorter than
2960       IF test%(3) >= test%(2) THEN EXIT loop
2970       BEEP 5000,70
2980     END REPeat loop
2990   END IF
3000 END DEFine SET_PRINT_QUALIFIERS
3010 :
3020 DEFine PROCedure REPORT_AN_ERROR (error_code)
3030   LOCal fer
3040   fer = error_code : BEEP 5000,50
3050   PRINT #0, : REMark ensure error message at start of line
3060   SELect ON fer
3070     =-100: PRINT #0,'Unsuitable file.'
3080     =-1  : PRINT #0,'Not complete.'
3090     =-3  : PRINT #0,'Out of memory.'
3100     =-4  : PRINT #0,'Out of range.'
3110     =-5  : PRINT #0,'Buffer full.'
3120     =-6  : PRINT #0,'Channel not open.'
3130     =-7  : PRINT #0,'Not found.'
3140     =-8  : PRINT #0,'Already exists.'
3150     =-9  : PRINT #0,'In use.'
3160     =-10 : PRINT #0,'End of file.'
3170     =-11 : PRINT #0,'Drive full.'
3180     =-12 : PRINT #0,'Bad name.'
3190     =-13 : PRINT #0,'XMIT error.'
3200     =-15 : PRINT #0,'Bad parameter.'
3210     =-16 : PRINT #0,'Bad or changed medium.'
3220     =-17 : PRINT #0,'Error in expression.'
3230     =-18 : PRINT #0,'Overflow.'
3240     =-19 : PRINT #0,'Not implemented.'
3250     =-20 : PRINT #0,'Read only.'
3260     =REMAINDER : PRINT #0,'Oops, error code ';fer
3270   END SELect
3280 END DEFine REPORT_AN_ERROR
3290 :
3300 DEFine FuNction YN$
3310   LOCal loop,key
3320   CURSOR_ON #0!
3330   REMark return y or n (either case) for yes/no reply
3340   REPeat loop
3350     key = CODE(INKEY$(-1))
3360     IF key=CODE('n') OR key=CODE('N') OR key=CODE('y') OR key=CODE('Y') THEN
3370       PRINT #0,CHR$(key) : EXIT loop
3380     END IF
3390   END REPeat loop
3400   CURSOR_OFF #0 : RETurn CHR$(key)
3410 END DEFine YN$
3420 :
3430 DEFine PROCedure LIST_OF_FILES
3440   LOCal loop,fer,pipe_fer,loop2
3450   drive_name$ = def_drive$ : pipe_fer = DEVICE_STATUS('pipe_4000')
3460   :
3470   IF COMPILED THEN
3480     WHEN_ERROR 0
3490       REPORT_AN_ERROR ERNUM% : CURSOR_ON #0! : PAUSE 100
3500       CURSOR_OFF #0 : RETRY
3510     END_WHEN
3520   END IF
3530   :
3540   REPeat loop
3550     RETRY_HERE : CLS #0
3560     PRINT #0,'LIST OF FILES-Enter drive name:-'\drive_name$;
3570     CURSOR_ON #0! : key = CODE(INKEY$(-1)) : CURSOR_OFF #0
3580     :
3590     IF key>=32 AND key<=191 AND key<>CODE('_') THEN
3600       drive_name$ = '' : AT #0,1,0 : CLS #0,4
3610       REMark underline allowed in order to specify wildcard
3620     END IF
3630     :
3640     IF key = 27 THEN
3650       drive_name$ = '' : key = 10 : AT #0,1,0 : CLS #0,4
3660     END IF
3670     :
3680     CURSOR_ON #0! : TYPE_IN CHR$(key) : CURSOR_OFF #0 : AT #0,1,0
3690     drive_name$ = EDIT$(#0,drive_name$,40)
3700     IF drive_name$ = '' THEN EXIT loop
3710     :
3720     IF LEN(drive_name$)>1 AND drive_name$(1)='?' THEN
3730       drive_name$=drive_name$(2 TO LEN(drive_name$))
3740     END IF
3750     loop = '__' INSTR drive_name$ : REMark search for wildcard
3760     IF loop = 5 THEN
3770       wcard$ = drive_name$(6 TO LEN(drive_name$))
3780       drive_name$ = drive_name$(1 TO 5)
3790     ELSE
3800       IF loop > 0 THEN
3810         wcard$ = drive_name$(loop+1 TO LEN(drive_name$))
3820         drive_name$ = def_drive$
3830       ELSE
3840         IF drive_name$(1)='_' THEN wcard$=drive_name$:drive_name$=def_drive$:ELSE wcard$='':END IF
3850       END IF
3860     END IF
3870     IF LEN(drive_name$) > 5 THEN drive_name$ = drive_name$(1 TO 5)
3880     IF LEN(wcard$)>10 THEN wcard$ = wcard$(1 TO 10)
3890     :
3900     fer = DEVICE_STATUS(drive_name$)
3910     IF fer = -8 OR fer = -9 OR fer = -20 OR fer >= 0 THEN
3920       REMark asking for list of files on default drive changes default drive name
3930       CLS #0 : def_drive$ = drive_name$
3940       IF pipe_fer < 0 THEN
3950         INK #0,4 : PRINT #0,'DIR output only:Press CTRL-F5 to pause.'
3960         INK #0,7 : DIR #0,drive_name$
3970         INK #0,4 : PRINT #0,'Press any key.'; : INK #0,7
3980         CURSOR_ON #0! : PAUSE : CURSOR_OFF #0 : EXIT loop
3990       ELSE
4000         REMark use PIPE for output DIR formatting in 2 columns
4010         OPEN #7,'pipe_4000' : CONNECT #7 TO #6 : DIR #7,drive_name$
4020         CLOSE #7
4030         INPUT #6,filename$ : INK #0,4 : PRINT #0,'MEDIUM NAME=';
4040         INK #0,7 : PRINT #0,filename$ : INPUT #6,filename$ : INK#0,4
4050         PRINT #0,'CAPACITY='; : INK #0,7 : PRINT #0,filename$
4060         loop = 3 : REMark 2 lines of display used + 1 blank line between medium info and filenames
4070         REPeat loop2
4080           IF EOF(#6) THEN
4090             CLOSE #6 : AT #0,loop MOD 20,40*(loop>19) : INK #0,4
4100             PRINT #0,'END OF LIST - PRESS ANY KEY '; : INK #0,7
4110             CURSOR_ON #0! : PAUSE : CURSOR_OFF #0 : EXIT loop2
4120           END IF
4130           INPUT #6,filename$ : REMark next name in list of files
4140           REMark where this name is to be printed
4150           AT #0,loop MOD 20,40*(loop>19)
4160           IF wcard$ = '' THEN
4170             REMark no wildcard so just print it
4180             PRINT #0,filename$; : loop = loop + 1
4190           ELSE
4200             IF LEN(filename$) >= LEN(wcard$) THEN
4210               IF filename$(LEN(filename$)-LEN(wcard$)+1 TO LEN(filename$))==wcard$ THEN PRINT#0,filename$;:loop=loop+1:END IF :REMark check for matching wildcard
4220             END IF
4230           END IF
4240           IF loop >= 39 THEN
4250              AT#0,loop MOD 20,40*(loop>19):INK#0,4
4260              PRINT #0,'PRESS ANY KEY FOR MORE '; : INK #0,7
4270              CURSOR_ON#0! : PAUSE : CURSOR_OFF#0 : CLS #0 : loop = 0
4280           END IF
4290         END REPeat loop2
4300         EXIT loop
4310       END IF
4320     ELSE
4330       REPORT_AN_ERROR fer : drive_name$ = def_drive$ : wcard$ = ''
4340     END IF
4350   END REPeat loop
4360   IF COMPILED THEN WHEN_ERROR 0 : CONTINUE : END_WHEN
4370 END DEFine LIST_OF_FILES
4380 :
4390 DEFine PROCedure COUNT_WORDS (method)
4400   this_entry$ = '' : REMark current word
4410   this_char$  = '' : REMark current byte from file
4420   cur_cde = 0      : REMark CODE(this_char$)
4430   word_count = 0   : REMark total of words in file
4440   diff_words = 0   : REMark number of different words found
4450   byte = 0         : REMark offset from base of text area
4460   :
4470   IF method = 2 THEN
4480     REMark from memory
4490     REMark +
4500     REPeat loop
4510       IF byte >= byts THEN EXIT loop
4520       cur_cde = PEEK(base+byte)
4530       byte = byte + 1
4540       this_char$ = CHR$(cur_cde)
4550       SELect ON cur_cde
4560         =65 TO 90,97 TO 122,128 TO 191 : REMark letter key
4570           this_entry$ = this_entry$&this_char$
4580         =48 TO 57 : REMark number key
4590           IF this_entry$ <> '' : this_entry$ = this_entry$&this_char$
4600         =39 : REMark apostrophes
4610           IF apostrophes = 49 THEN
4620             REMark no need to do anything except ignore it!
4630           ELSE
4640             REMark apostrophe to be taken into consideration
4650             REMark method 1 as before allows split of words
4660             IF apostrophes = 50 THEN
4670               REMark apostrophe=end of word
4680               IF this_entry$ <> '' THEN
4690                 word_count = word_count + 1
4700                 Add_To_Dic this_entry$
4710                 this_entry$ = ''
4720                 AT #0,5,0 : PRINT #0,diff_words&'/'&word_count
4730                 IF diff_words >= highest_entry THEN EXIT loop
4740               END IF
4750             ELSE
4760               REMark Paul Merdinian method, where the 's is added to
4770               REMark the end of the word unless it is a closing quote
4780               REMark identified by being followed by non-alphanumeric
4790               REMark (e.g. SPACE) character
4800               REMark "byte" is now pointing to NEXT character after
4810               REMark apostrophe
4820               IF byte < byts THEN
4830                 IF (PEEK$(base+byte,1) INSTR 'abcdefghijklmnopqrstuvwxyz0123456789') > 0 THEN
4840                   REMark not a word end, just ignore "'" in middle
4850                   REMark of word
4860                   NEXT loop
4870                 END IF
4880               END IF
4890               REMark word end
4900               IF this_entry$ <> '' THEN
4910                 word_count = word_count + 1
4920                 Add_To_Dic this_entry$
4930                 this_entry$ = '' : AT #0,5,0
4940                 PRINT #0,diff_words&'/'&word_count
4950               END IF
4960             END IF
4970           END IF
4980         =REMAINDER : REMark treat as word end
4990           IF this_entry$ <> '' THEN
5000             word_count = word_count+1
5010             Add_To_Dic this_entry$
5020             this_entry$ = ''
5030             AT #0,5,0 : PRINT #0,diff_words&'/'&word_count
5040             IF diff_words >= highest_entry THEN EXIT loop
5050           END IF
5060       END SELect
5070     END REPeat loop
5080     REMark -
5090   ELSE
5100     REMark count direct from file
5110     REMark +
5120     REPeat loop
5130       IF EOF(#3) : CLOSE #3 : EXIT loop
5140       this_char$ = INKEY$(#3)
5150       cur_cde = CODE(this_char$)
5160       SELect ON cur_cde
5170         =65 TO 90,97 TO 122,128 TO 191
5180           this_entry$ = this_entry$&this_char$
5190         =48 TO 57:REMark number
5200           IF this_entry$<>'':this_entry$=this_entry$&this_char$
5210         =39 : REMark various ways of dealing with apostrophe
5220           IF apostrophes = 1 THEN
5230             REMark no need to do anything
5240           ELSE
5250             REMark apostrophe to be taken into consideration
5260             REMark method 1 as before allows split of words
5270             IF apostrophes = 2 THEN
5280               IF this_entry$ <> '' THEN
5290                 word_count = word_count + 1
5300                 Add_To_Dic this_entry$ : this_entry$ = ''
5310                 AT #0,5,0 : PRINT #0,diff_words&'/'&word_count
5320                 IF diff_words >= highest_entry : EXIT loop
5330               END IF
5340             ELSE
5350               REMark Paul Merdinian method, where the 's is added to
5360               REMark the end of the word unless a closing quote,
5370               REMark identified by being followed by a non-
5380               REMark alphanumeric character
5390               REMark "byte" is now pointing to NEXT character after '
5400               IF byte < byts THEN
5410                 IF (INKEY$(#3) INSTR 'abcdefghijklmnopqrstuvwxyz0123456789') > 0 THEN
5420                   REMark not a word end, just ignore "'" in word middle
5430                   NEXT loop
5440                 END IF
5450               END IF
5460               REMark word end
5470               IF this_entry$ <> '' THEN
5480                 word_count = word_count + 1
5490                 Add_To_Dic this_entry$
5500                 this_entry$ = '' : AT #0,5,0
5510                 PRINT #0,diff_words&'/'&word_count
5520                 IF diff_words >= highest_entry THEN EXIT loop
5530               END IF
5540             END IF
5550           END IF
5560         =REMAINDER
5570           IF this_entry$<>'' THEN
5580             word_count = word_count + 1
5590             Add_To_Dic this_entry$
5600             this_entry$ = ''
5610             AT #0,5,0 : PRINT #0,diff_words&'/'&word_count
5620             IF diff_words >= highest_entry THEN EXIT loop
5630           END IF
5640       END SELect
5650     END REPeat loop
5660     REMark -
5670   END IF
5680   :
5690   CLS #0
5700   PRINT#0,'Finished counting, please wait a little longer...'
5710   longest%  = 0 : REMark longest word
5720   oftenest% = 0 : REMark highest number of occurrences
5730   addr      = base_addr
5740   REMark +
5750   REMark used to be 'a' not 'all',limited max to 32K words pre v1.20!
5760   FOR all = 0 TO diff_words-1
5770     IF PEEK_W(addr) > longest% THEN longest% = PEEK_W(addr)
5780     IF PEEK_L(addr+2) > oftenest% THEN oftenest% = PEEK_L(addr+2)
5790     addr = addr + entry_length :REMark point to next entry
5800   END FOR all
5810   REMark -
5820   :
5830   CLS #0
5840   PRINT #0,'Total number of words in ';filename$;'=';word_count
5850   PRINT #0,'Number of different words=';diff_words
5860   PRINT #0,'Longest word was ';longest%;' characters long.'
5870   :
5880   REMark set default values for test qualifiers
5890   REMark more often than, less often than, longer than, shorter than
5900   test%(0) = 0 : test%(1) = oftenest% + 1 : test%(2) = 0
5910   test%(3) = longest% + 1
5920   :
5930   PRINT #0,'Print count after each word Y/N?'; : print_count% = 1
5940   IF YN$ == 'n' THEN print_count% = 0
5950   :
5960   PRINT #0,'Screen list of words used (y/n)?';
5970   IF YN$ == 'y' THEN
5980     REPeat list_the_words
5990       REMark longer than,shorter than,more often than,less often than
6000       SET_PRINT_QUALIFIERS
6010       REMark formatted output to screen
6020       CLS #0 : PAPER #0,2 : CLS #0,3 : REMark whole of cursor line
6030       fetch$ = 'LIST OF WORDS USED IN '&filename$
6040       PRINT #0,TO LEN(fetch$)/2;fetch$
6050       PAPER #0,0 : x% = 0 : y% = 1
6060       addr = base_addr : REMark wade through list
6070       FOR word_list = 0 TO diff_words-1
6080         ok% = 1 : REMark if this stays at 1, the word will be printed, if it changes to 0 during the tests the word will not be printed
6090         IF qualifiers% <> 0 THEN
6100           REMark apply tests
6110           IF PEEK_L(addr+2) <= test%(0) THEN ok% = 0
6120           REMark IF occurrences%(word_list) <= test%(0) THEN ok%=0
6130           IF PEEK_L(addr+2) >= test%(1) THEN ok% = 0
6140           REMark IF occurrences%(word_list) >= test%(1) THEN ok%=0
6150           IF PEEK_W(addr) <= test%(2) THEN ok% = 0
6160           REMark IF LEN(words$(word_list)) <= test%(2) THEN ok%=0
6170           IF PEEK_W(addr) >= test%(3) THEN ok% = 0
6180           REMark IF LEN(words$(word_list)) >= test%(3) THEN ok%=0
6190         END IF
6200         IF ok% = 1 THEN
6210           REMark print word$ (occurrences)
6220           AT #0,y%,x%
6230           PRINT #0,PEEK$(addr+6,PEEK_W(addr));
6240           IF print_count% = 1 THEN
6250             PRINT #0,' (';PEEK_L(addr+2);')';
6260           END IF
6270           x% = x% + 40 : IF x% > 40 THEN y% = y% + 1 : x% = 0
6280           IF y% > 18 THEN
6290             REMark pause after screenful
6300             AT #0,19,0 : INK #0,4
6310             PRINT #0,'PRESS ANY KEY TO CONTINUE WITH THE LISTING';
6320             INK #0,7 : CURSOR_ON #0!
6330             IF INKEY$(-1) = CHR$(27) THEN
6340               CURSOR_OFF #0 : EXIT word_list
6350             END IF
6360             CURSOR_OFF #0
6370             AT #0,1,0 : CLS #0,3 : CLS #0,2 : x% = 0 : y% = 1
6380           END IF
6390         END IF
6400         addr = addr + entry_length
6410       END FOR word_list
6420       AT #0,19,0 : PAPER #0,4 : INK #0,0
6430       CLS #0,3 : REMark whole of cursor line
6440       PRINT#0,'WORD COUNT=';word_count;' (';diff_words;' DIFFERENT WORDS). PRESS ANY KEY.';
6450       PAPER #0,0 : INK #0,7 : CURSOR_ON #0! : PAUSE : CURSOR_OFF #0
6460       CLS #0 : PRINT #0,'List to screen again (y/n)?';
6470       IF YN$ == 'n' THEN EXIT list_the_words
6480     END REPeat list_the_words
6490   END IF
6500   :
6510   CLS #0 : PRINT #0,'Printout of words used (y/n)?';
6520   IF YN$ == 'y' THEN
6530     REPeat list_the_words
6540       SET_PRINT_QUALIFIERS : pf$ = printer$
6550       REPeat loop
6560         REMark get print destination
6570         RETRY_HERE : CLS #0 : PRINT #0,'Print to:';pf$;
6580         CURSOR_ON#0! : key = CODE(INKEY$(-1)) : CURSOR_OFF #0
6590         SELect ON key
6600           =63 : REMark list of files
6610             LIST_OF_FILES
6620             IF COMPILED THEN
6630               WHEN_ERROR 0
6640                 REPORT_AN_ERROR ERNUM%
6650                 CURSOR_ON #0! : PAUSE 100 : CURSOR_OFF #0 : NEXT loop
6660               END_WHEN
6670             END IF
6680             NEXT loop
6690           =27 : REMark escape
6700             AT #0,0,9 : CLS #0,4 : PRINT #0,'<ESC>' : EXIT loop
6710           =244,250 : REMark refresh (change in v1.20=no MODE 4)
6720             WINDOW #0,448,202,32,15 : BORDER#0,1,255
6730             PAPER  #0,0 : CLS #0 : NEXT loop
6740           =REMAINDER : REMark change to filename
6750             CURSOR_ON #0! : TYPE_IN CHR$(key) : CURSOR_OFF #0
6760             AT #0,0,9 : pf$ = EDIT$(#0,pf$,41)
6770             IF pf$ = '' THEN key = 27 : EXIT loop
6780             IF pf$ = '?' THEN
6790               LIST_OF_FILES
6800               IF COMPILED THEN
6810                 WHEN_ERROR 0
6820                   REPORT_AN_ERROR ERNUM%
6830                   CURSOR_ON #0! : PAUSE 100 : CURSOR_OFF #0 : RETRY
6840                 END_WHEN
6850               END IF
6860               NEXT loop
6870             END IF
6880             pfer = DEVICE_STATUS(pf$)
6890             IF pfer = -8 THEN
6900               PRINT #0,'Already exists. Delete (y/n)?';
6910               IF YN$ == 'n' THEN NEXT loop
6920               DELETE pf$ : pfer = DEVICE_STATUS(pf$)
6930             END IF
6940             IF pfer < 0 THEN
6950               REPORT_AN_ERROR pfer
6960               CURSOR_ON #0! : PAUSE 100 : CURSOR_OFF #0 : NEXT loop
6970             END IF
6980             printer$ = pf$ : EXIT loop
6990         END SELect
7000       END REPeat loop
7010       k$ = ''
7020       IF key = 27 THEN EXIT list_the_words
7030       OPEN_NEW #3,printer$ : REMark use _NEW allows file output too
7040       PRINT #0,'Printing (press ESC to quit)...'
7050       IF print_count% = 1 THEN
7060         PRINT#3,'LIST OF WORDS USED IN ';filename$
7070       END IF
7080       CURSOR_ON #0! : addr = base_addr
7090       FOR word_list = 0 TO diff_words - 1
7100         ok% = 1
7110         IF qualifiers% <> 0 THEN
7120           IF PEEK_L(addr+2) <= test%(0) OR PEEK_L(addr+2) >= test%(1) THEN ok% = 0
7130           IF PEEK_W(addr) <= test%(2) OR PEEK_W(addr) >= test%(3) THEN ok% = 0
7140         END IF
7150         IF ok% = 1 THEN
7160           PRINT #3,PEEK$(addr+6,PEEK_W(addr));
7170           IF print_count% = 1 THEN
7180             PRINT #3,' (';PEEK_L(addr+2);')'
7190           ELSE
7200             PRINT #3,
7210           END IF
7220           IF INKEY$ = CHR$(27) THEN EXIT word_list
7230         END IF
7240         addr = addr + entry_length
7250         NEXT word_list
7260         IF print_count% = 1 THEN
7270           PRINT #3,'WORD COUNT=';word_count;' (';diff_words;' DIFFERENT WORDS).'
7280           PRINT #3,'LONGEST WORD WAS ';longest%;' CHARACTER';
7290           IF longest% <> 1 THEN PRINT#3,'S';
7300           PRINT #3,' LONG.'
7310         END IF
7320       END FOR word_list
7330       CLOSE #3 : CURSOR_OFF #0 : CLS #0
7340       PRINT #0,'Another printout (y/n)?';
7350       IF YN$ == 'n' THEN EXIT list_the_words
7360     END REPeat list_the_words
7370   END IF
7380 END DEFine COUNT_WORDS
7390 :
7400 DEFine PROCedure Put_In_List (plce,f$)
7410   LOCal entry_addr
7420   REMark insert f$ at element "plce", recalculate address
7430   entry_addr = base_addr+(entry_length*plce)
7440   IF plce < diff_words THEN
7450     REMark move them up to make room!
7460     MOVE_MEMORY entry_addr TO entry_addr+entry_length,-((diff_words-plce)*entry_length)
7470   END IF
7480   POKE_W entry_addr,LEN(f$)  : REMark length of word
7490   POKE_L entry_addr+2,1      : REMark first occurrence
7500   POKE$  entry_addr+6,f$     : REMark the word itself
7510 END DEFine Put_In_List
7520 :
7530 DEFine PROCedure Add_To_Dic (n$)
7540   IF diff_words = 0 THEN
7550     POKE_W base_addr,LEN(n$) : REMark length of new word
7560     POKE_L base_addr+2,1     : REMark first occurrence (new word)
7570     POKE$  base_addr+6,n$    : REMark the word itself
7580     REMark place = 0 : REMark may not be needed
7590     diff_words = 1
7600   ELSE
7610     place = Already_In_List (n$)
7620     IF place = -1 THEN
7630       REMark already in list, increment counter
7640       POKE_L entry_addr+2,PEEK_L(entry_addr+2)+1
7650     ELSE
7660       Put_In_List place,n$
7670       diff_words = diff_words+1
7680     END IF
7690   END IF
7700 END DEFine Add_To_Dic
7710 :
7720 REMark +
7730 DEFine FuNction Already_In_List (f$)
7740   LOCal hi,lo,mid,loop,t$(100)
7750   hi=diff_words-1 : REMark highest entry subscript
7760   lo = 0          : REMark lowest entry subscript
7770   REPeat loop
7780     mid = INT((lo+hi)/2)
7790     REMark global variable
7800     entry_addr = base_addr+(entry_length*mid)
7810     t$ = PEEK$(entry_addr+6,PEEK_W(entry_addr))
7820     IF t$ == f$ THEN
7830       mid = -1 : EXIT loop : REMark exists in list, do not insert
7840     ELSE
7850       REMark to prevent case errors, convert to upper case for
7860       REMark comparison - this helps prevent Paul Merdinian's case
7870       REMark errors in the listings, where upper case and lower case
7880       REMark words can get separated by intermediate upper cases
7890       IF U_CASE$(t$) > U_CASE$(f$) THEN
7900         REMark move pointer down list
7910         hi = mid - 1
7920         IF lo > hi THEN EXIT loop
7930       ELSE
7940         REMark move pointer up list
7950         lo = mid + 1
7960         IF lo > hi THEN mid = lo : EXIT loop
7970       END IF
7980     END IF
7990   END REPeat loop
8000   RETurn mid : REMark -1=in list,>=0=subscript at which to insert
8010 END DEFine Already_In_List
8020 REMark -
